#ifndef CUBIC_H
#define CUBIC_H 1

#include <math.h>

#ifdef SUN
#  include <sunmath.h>
#endif

#include "precision.h"

#ifndef NOASINH
#define ASINH(s)	(REAL)asinh((double)s)
#else
#define ASINH(s)	asinh_rf(s)
REAL asinh_rf();
#endif

#ifndef SQRT3
#  define SQRT3		1.732050807568877293527446341505872366943
#endif

#define NONE		0
#define ONE		1
#define TRIPLE		10
#define UPPER_DOUBLE	20
#define LOWER_DOUBLE	21
#define THREE		3

typedef struct {int type; REAL x0, xm, xp;} roots3;

int cubic(), cubic_oo();
int cubic_improve(), croot_improve(), czoot_improve();
int elintF(), elint1(), elintr1(), rf();

#endif /* cubic.h */
