/*
   Fortran interface to elliptic integral of the 1st kind elint1().
   Called as fortran real*8 function
      elint1(l, tl, tu, a, b, c)
   l = 0, 1, 2 determines interpretation of a, b, c.

   See elint1.c for details.
*/
#include "cubic.h"

double elint1_(l, tl, tu, a, b, c)
int *l;
double *tl, *tu, *a, *b, *c;
{
    int ier;
    double e;

    ier = elint1(*l, *tl, *tu, *a, *b, *c, &e);

    return(e);
}
