/* Program to test cubic.c and elint1.c */

#include <stdio.h>
#include <string.h>
#include "cubic.h"

#define PI	M_PI

#ifdef DOUBLE
#  define ROUND 	1.e-11
#else
#  define ROUND 	1.e-5
#endif

#define CUBIC	0
#define ELINT	1

void	test_cubic();

int main(int argc, char **argv)
{
    test_cubic();
    return(0);
}

/* test that cube roots and elliptic integral are working */
void test_cubic()
{
    int i, ier, iers;
    REAL a, b, c, achk, bchk, cchk, er, tl, tu;
    roots3 rt;
/*
    char ch;
    int ierl, ierr, ier0, imax, ia, ib, ic, it, l;
    REAL da, db, dc, dl, d0, el, e0;
    roots3 in;
*/

    printf("%s\n%s\n%s\n%s\n%s\n%s\n%s\n",
	"solve cubic x^3 + a x^2 + b x + c,",
	"then elliptic integral",
	"     tu",
	"1   /            dt",
	"-   |  --------------------------",
	"2   /                         1/2",
	"   tl  (t^3 + a t^2 + b t + c)"
    );

    while (1) {
	printf("----------------------------------------\n");
	printf("enter a b c: ");
#ifdef DOUBLE
	i = scanf("%lf%*[ \t,;:]%lf%*[ \t,;:]%lf", &a, &b, &c);
#else
	i = scanf("%f%*[ \t,;:]%f%*[ \t,;:]%f", &a, &b, &c);
#endif
	if (i != 3) break;
	iers = ier = cubic(a, b, c, &rt);
        if (ier != 0) printf("cubic failed\n");
	printf("x0 = %.16lg; enter tl tu: ", rt.x0);
#ifdef DOUBLE
	i = scanf("%lf%*[ \t,;:]%lf", &tl, &tu);
#else
	i = scanf("%f%*[ \t,;:]%f", &tl, &tu);
#endif
	if (i != 2) break;
	iers += ier = elintr1(tl, tu, &rt, &er);
        if (ier != 0) printf("elint1 failed\n");
	if (rt.type == ONE) {
	    achk = -(rt.x0 + 2. * rt.xm);
	    bchk = rt.x0 * 2. * rt.xm + rt.xm * rt.xm + rt.xp * rt.xp;
	    cchk = -(rt.x0 * (rt.xm * rt.xm + rt.xp * rt.xp));
	    printf("roots = %.16lg %.16lg  I %.16lg\n",
		(double)rt.x0, (double)rt.xm, (double)rt.xp);
	} else {
	    achk = -(rt.x0 + rt.xm + rt.xp);
	    bchk = rt.x0 * (rt.xm + rt.xp) + rt.xm * rt.xp;
	    cchk = -(rt.x0 * rt.xm * rt.xp);
	    printf("roots = %.16lg %.16lg %.16lg\n",
		(double)rt.x0, (double)rt.xm, (double)rt.xp);
	    printf("type = %d\n", rt.type);
	}
	printf("a b c =\n%.16lg %.16lg %.16lg\n%.16lg %.16lg %.16lg\n",
	    (double)a, (double)b, (double)c,
	    (double)achk, (double)bchk, (double)cchk);
	printf("elint1 = %.16lg\n", (double)er);
    }

/*
    printf("enter tl tu: ");

#ifdef DOUBLE
    i = scanf("%lf%*[ \t,;:]%lf", &tl, &tu);
#else
    i = scanf("%f%*[ \t,;:]%f", &tl, &tu);
#endif
    if (i != 2) return;

    imax = 100;
    for (it = 0; it <= 2; it++) {
	in.type = (it == 0)? ONE : THREE;
	for (ia = -imax; ia <= imax; ia++) {
	    for (ib = -imax; ib <= imax; ib++) {
		for (ic = (in.type == ONE)? 0 : -imax; ic <= imax; ic++) {
		    a = ia;
		    b = ib;
		    c = ic;
// a = tan(PI/2 * a / (double)(imax + 1)); b = tan(PI/2 * b / (double)(imax + 1)); c = tan(PI/2 * c / (double)(imax + 1));
		    in.x0 = a;
		    in.xm = b;
		    in.xp = c;
		    if (in.type == ONE) {
			a = -(in.x0 + 2. * in.xm);
			b = in.x0 * 2. * in.xm + in.xm * in.xm + in.xp * in.xp;
			c = -(in.x0 * (in.xm * in.xm + in.xp * in.xp));
		    } else {
			a = -(in.x0 + in.xm + in.xp);
			b = in.x0 * (in.xm + in.xp) + in.xm * in.xp;
			c = -(in.x0 * in.xm * in.xp);
		    }
		    if (isnan(a) || isnan(b) || isnan(c)) break;
		    iers = ier = cubic(a, b, c, &rt);
		    if (ier != 0) {
			printf("cubic failed\n");
			d0 = 0.;
			dl = 0.;
		    } else {
			iers += ier = 0; // cubic_improve(&a, &b, &c, &rt);
			if (ier != 0) {
			   printf("cubic_improve failed to converge for %d roots\n", ier);
			}
			if (rt.type == ONE) {
			    l = 2;
			} else {
			    l = 1;
			}
			ierr = elintr1(tl, tu, &rt, &er);
			ier = (ierr == 1)? 0 : ierr;
			iers += ier;
			if (ier != 0) {
			   printf("elintr1 failed\n");
			}
			ier0 = elint1(0, tl, tu, a, b, c, &e0);
			ier = (ier0 == 1)? 0 : ier0;
			iers += ier;
			if (ier != 0) {
			   printf("elint1(0,...) failed\n");
			}
			if (ier0 != ierr) {
			   printf("ier0 = %d should = ierr = %d\n", ier0, ierr);
			}
			ierl = elint1(l, tl, tu, rt.x0, rt.xm, rt.xp, &el);
			ier = (ierl == 1)? 0 : ierl;
			iers += ier;
			if (ier != 0) {
			   printf("elint1(%d,...) failed\n", l);
			}
			if (ierl != ierr) {
			   printf("ierl = %d should = ierr = %d\n", ierl, ierr);
			}
			d0 = fabs(e0 - er) / (1. + fabs(er));
			dl = fabs(el - er) / (1. + fabs(er));
			if (d0 >= ROUND || dl >= ROUND) {
			    iers++;
			    printf("er = %lf e0 = %lf el = %lf disagree type = %d\n", er, e0, el, rt.type);
			}
		    }
		    if (rt.type == ONE) {
			achk = -(rt.x0 + 2. * rt.xm);
			bchk = rt.x0 * 2. * rt.xm + rt.xm * rt.xm + rt.xp * rt.xp;
			cchk = -(rt.x0 * (rt.xm * rt.xm + rt.xp * rt.xp));
		    } else {
			achk = -(rt.x0 + rt.xm + rt.xp);
			bchk = rt.x0 * (rt.xm + rt.xp) + rt.xm * rt.xp;
			cchk = -(rt.x0 * rt.xm * rt.xp);
		    }
		    if (rt.type != ONE && (rt.x0 > rt.xm || rt.xm > rt.xp)) {
			iers++;
			printf ("roots out of order\n");
		    }
		    da = fabs(a - achk) / (1. + fabs(a));
		    db = fabs(b - bchk) / (1. + fabs(b));
		    dc = fabs(c - cchk) / (1. + fabs(c));
		    if (da >= ROUND) printf("1st ");
		    if (db >= ROUND) printf("2nd ");
		    if (dc >= ROUND) printf("3rd ");
		    if (da >= ROUND || db >= ROUND || dc >= ROUND) {
			iers++;
			printf("coefficient discrepant:\n");
		    }
		    if (iers != 0) {
			printf("a b c =\n%.16lg %.16lg %.16lg\n%.16lg %.16lg %.16lg\n",
			    (double)a, (double)b, (double)c,
			    (double)achk, (double)bchk, (double)cchk);
			if (in.type == ONE) {
			    printf("   in = %.16lg %.16lg  I %.16lg\n",
				(double)in.x0, (double)in.xm, (double)in.xp);
			} else {
			    printf("   in = %.16lg %.16lg %.16lg\n",
				(double)in.x0, (double)in.xm, (double)in.xp);
			}
			if (rt.type == ONE) {
			    printf("roots = %.16lg %.16lg  I %.16lg\n",
				(double)rt.x0, (double)rt.xm, (double)rt.xp);
			} else {
			    printf("roots = %.16lg %.16lg %.16lg\n",
				(double)rt.x0, (double)rt.xm, (double)rt.xp);
			    printf("type = %d\n", rt.type);
			}
			printf("enter CR to continue: ");
			scanf("%c", &ch);
			if (strchr("qQxX", ch)) exit();
		    }
		}
	    }
	}
    }
*/
}
